%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%          Copyright (c) 2013 K. Neumann, CoR-Lab                     %%%
%%%          Bielefeld University, Germany, http://cor-lab.de           %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

classdef CEQC
    
    properties

        SamplesPerIteration = 1;        %samples per iteraion
        TestSamplesPerIteration = 1000; %test samples per iteraion
        SamplingRegion = 0;     
        partial = {};                   %define constraints through partial derivatives
        factors = [];    
        Value = 1;                   %bounds on the maximal partial derivative
        maxTestValue = 0;               %bounds on the maximal partial derivative (test value, usually higher then maxValue)
        minTestValue = 0;              %bounds on the minimal partial derivative (test value, usually lower then minValue)
        StabilityThreshold = 0.998;     %stop with iteration until StabilityThreshold percent of the samples fulfill the constraint
        u = [];                         %samples of the constraint %continuous inequality constraint
        inpDim = 1;                     %input dimension
        
        model = 'CIEQ';
    end
    
    methods
        function l = CEQC(spec)
            if nargin > 0
                for s=1:size(spec,1)
                    if ~strcmp(spec{s,1}, 'class')
                        try
                            l.(spec{s,1}) = spec{s,2};
                        catch me
                            disp(me.message);
                        end
                    end
                end
            end
        end
        
        function s = getDescriptorString(l)
            s = ['CIEQ']; 
        end
        
        function uTestSamples = DrawTestSamples(l)
            uTestSamples = l.SamplingRegion.DrawTestSamples(l.TestSamplesPerIteration);
        end
    end
    
end

