%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%          Copyright (c) 2013 K. Neumann, CoR-Lab                     %%%
%%%          Bielefeld University, Germany, http://cor-lab.de           %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

classdef DEQC
    
    properties

        partial = {};                   %define constraints through partial derivatives
        factors = [];    
        Value = 1;                   %bounds on the maximal partial derivative
        u = [];                         %samples of the constraint %continuous inequality constraint
        inpDim = 1;                     %input dimension
        
        model = 'DEQ';
    end
    
    methods
        function l = DEQC(spec)
            if nargin > 0
                for s=1:size(spec,1)
                    if ~strcmp(spec{s,1}, 'class')
                        try
                            l.(spec{s,1}) = spec{s,2};
                        catch me
                            disp(me.message);
                        end
                    end
                end
            end
        end
        
        function s = getDescriptorString(l)
            s = ['DEQ']; 
        end
    end
    
end

