%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%          Copyright (c) 2013 K. Neumann, CoR-Lab                     %%%
%%%          Bielefeld University, Germany, http://cor-lab.de           %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

classdef SamplingRegion
    
    properties

        IndicatorFunction = @(x) (1);
        WS_max = [];        %max border of input region where sampling takes place
        WS_min = [];        %min border of input region where sampling takes place
        inpDim = 1;      
        
        model = 'SR';
    end
    
    methods
        function l = SamplingRegion(spec)
            if nargin > 0
                for s=1:size(spec,1)
                    if ~strcmp(spec{s,1}, 'class')
                        try
                            l.(spec{s,1}) = spec{s,2};
                        catch me
                            disp(me.message);
                        end
                    end
                end
            end
        end
        
        function s = getDescriptorString(l)
            s = ['SR']; 
        end
        
        function uTestSamples = DrawTestSamples(l, NumSamples)
            l.inpDim = length(l.WS_max);
            uTestSamples = zeros(NumSamples,l.inpDim);
            counter = 0;
            while counter < NumSamples
                TempSample = zeros(1,l.inpDim);
                for d = 1:l.inpDim
                    TempSample(d) = (l.WS_max(d)-l.WS_min(d))*rand+l.WS_min(d);
                end
                if l.IndicatorFunction(TempSample)==1
                    counter = counter + 1;
                    uTestSamples(counter,:) = TempSample;
                end
            end
        end
    end
    
end

