
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%          Copyright (c) 2013 K. Neumann, CoR-Lab                     %%%
%%%          Bielefeld University, Germany, http://cor-lab.de           %%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function val = fermiDerivative(num_degree)
    % ... + a_i*f^m_i*(1-f)^n_i + ... -> (...,a_i,m_i,n_i,...)
    
    if num_degree == 0
        val = [1 1 0];
    elseif num_degree == 1
        val = [1 1 1];
    elseif num_degree == 2
        val = [-1 2 1;1 1 2];
    elseif num_degree == 3
        val = [1 3 1;-4 2 2;1 1 3];
    elseif num_degree == 4
        val = [-1 4 1;11 3 2;-11 2 3;1 1 4];
    elseif num_degree == 5
        val = [1 5 1;-26 4 2;66 3 3;-26 2 4; 1 1 5];
    elseif num_degree == 6
        val = [-1 6 1;57 5 2;-302 4 3;302 3 4;-57 2 5;1 1 6];
    elseif num_degree == 7
        val = [1 7 1;-120 6 2;1191 5 3;-2416 4 4;1191 3 5;-120 2 6;1 1 7];
    else
    
        val = [1,1,0];
        for i = 1:num_degree
            [sX,sY] = size(val);
            new = [];
            for j = 1:sX
                new = [new; val(j,1)*val(j,2),val(j,2),val(j,3)+1 ; -val(j,1)*val(j,3),val(j,2)+1,val(j,3)];
            end
            val = new;
        end
        [sX,sY] = size(val);
        val = val(1:round(sX/2),:);
        for i = 1:num_degree
            prod = sum( val(val(:,2)==num_degree-i+1&val(:,3)==i) );
            val(val(:,2)==num_degree-i+1&val(:,3)==i,:) = [];
            if prod ~= 0
                val = [val;prod,num_degree-i+1,i];
            end
        end   
        
    end
end
% 1.855 s



%         function val = fermi1(obj,x,w,a,b)
%             f = obj.fermi(x,w,a,b);
%             val = a*w*(f*(1-f));
%         end
%         function val = fermi2(obj,x,w,a,b)
%             f = obj.fermi(x,w,a,b);
%             val = (w*a)^2*(f.*(1-f).^2 - f.^2.*(1-f));
%         end
%         function val = fermi3(obj,x,w,a,b)
%             f = obj.fermi(x,w,a,b);
%             val = (w*a)^3*( f.*(1-f).^3 -4*f.^2.*(1-f).^2 +f.^3.*(1-f) );
%         end
%         function val = fermi4(obj,x,w,a,b)
%             f = obj.fermi(x,w,a,b);
%             val = (w*a)^4*( f.*(1-f).^4 -11*f.^2.*(1-f).^3 +11*f.^3.*(1-f).^2 -f.^4.*(1-f) );
%         end
