
%% XML
% <?xml version="1.0" encoding="UTF-8"?>
% <MLlib_XML_File>
%     <MachineLearningModel modelName="Mlp_Neural_Network">
%         <Configuration int_numInputNeurons="4" int_numLayers="4" bool_usesBias="true">
%             <MlpLayer1 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
%             <MlpLayer2 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
%             <MlpLayer3 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
%             <MlpLayer4 int_numNeurons="3" str_activationFunction="ACT_FN_SIGMOID"/>
%         </Configuration>
%         <Parameters str_engine="mlp_' enc '_engine" int_numLayers="4" bool_usesBias="true">
%             <MlpLayer1 str_type="dense" str_activationFunction="ACT_FN_SIGMOID">
%                 <WeightMatrix str_type="' enc '" int_rows="6" int_columns="5">
%                     <Row1 arr' enc '_vals="0.455443,0.301906,0.541781,-0.253339,-0.639187"/>
%                     <Row2 arr' enc '_vals="0.891971,-0.129105,0.357915,-0.744195,-0.277263"/>
%                     <Row3 arr' enc '_vals="-0.347602,0.323089,-0.912997,-0.23274,0.314637"/>
%                     <Row4 arr' enc '_vals="-0.211747,-0.636116,-0.736092,0.0251508,0.696611"/>
%                     <Row5 arr' enc '_vals="-0.099763,-0.42249,-0.127794,0.311451,-0.75072"/>
%                     <Row6 arr' enc '_vals="0.692093,0.819697,-0.30946,0.30172,0.330007"/>
%                 </WeightMatrix>
%             </MlpLayer1>
%             <MlpLayer2 str_type="dense" str_activationFunction="ACT_FN_SIGMOID">
%                 <WeightMatrix str_type="' enc '" int_rows="6" int_columns="7">
%                     <Row1 arr' enc '_vals="-0.269889,0.489026,-0.256747,0.50231,-0.929018,-0.695505,-0.291212"/>
%                     <Row2 arr' enc '_vals="0.933973,0.974135,0.809468,0.636652,-0.0812703,0.11935,-0.248013"/>
%                     <Row3 arr' enc '_vals="-0.543179,-0.0722411,0.401044,-0.565518,-0.181423,-0.994171,-0.386165"/>
%                     <Row4 arr' enc '_vals="0.146087,0.0637395,-0.761143,-0.745139,0.0680933,-0.0390097,-0.89726"/>
%                     <Row5 arr' enc '_vals="-0.0735264,0.793771,0.329143,0.657608,-0.638328,0.773894,0.712063"/>
%                     <Row6 arr' enc '_vals="-0.194129,0.693904,-0.855701,0.0451016,0.842135,0.612315,-0.693502"/>
%                 </WeightMatrix>
%             </MlpLayer2>
%             <MlpLayer3 str_type="dense" str_activationFunction="ACT_FN_SIGMOID">
%                 <WeightMatrix str_type="' enc '" int_rows="6" int_columns="7">
%                     <Row1 arr' enc '_vals="0.554012,-0.890491,-0.565411,0.99554,0.695893,-0.422576,0.131688"/>
%                     <Row2 arr' enc '_vals="-0.816567,0.938933,0.0584266,-0.147376,-0.111313,0.555788,0.561335"/>
%                     <Row3 arr' enc '_vals="0.601519,0.758418,0.16975,-0.458127,-0.556778,-0.693084,0.342627"/>
%                     <Row4 arr' enc '_vals="-0.176838,0.337759,-0.780298,-0.163226,0.320003,-0.182413,-0.646243"/>
%                     <Row5 arr' enc '_vals="0.420975,-0.4688,0.311748,-0.52081,-0.566908,0.644412,-0.442143"/>
%                     <Row6 arr' enc '_vals="0.786864,0.289475,0.153849,-0.011869,-0.581833,0.401254,0.0437934"/>
%                 </WeightMatrix>
%             </MlpLayer3>
%             <MlpLayer4 str_type="dense" str_activationFunction="ACT_FN_SIGMOID">
%                 <WeightMatrix str_type="' enc '" int_rows="3" int_columns="7">
%                     <Row1 arr' enc '_vals="0.399241,-0.19721,0.292457,-0.813489,-0.279939,0.901192,-0.676194"/>
%                     <Row2 arr' enc '_vals="0.0038439,-0.525608,-0.0770947,-0.427942,0.892864,-0.86446,-0.560891"/>
%                     <Row3 arr' enc '_vals="0.64038,0.947651,-0.99761,-0.376048,0.597221,-0.817446,-0.783316"/>
%                 </WeightMatrix>
%             </MlpLayer4>
%         </Parameters>
%     </MachineLearningModel>
% </MLlib_XML_File>

%% functions    
function xml = net2xml(net, fnstr, enc)
    if nargin < 3
        enc = 'fp32';
    end
    
    xml = [];
    xml = [xml '<?xml version="1.0" encoding="UTF-8"?>\n'];
    xml = [xml '<MLlib_XML_File>\n'];
    xml = [xml '\t<MachineLearningModel modelName="Mlp_Neural_Network">\n'];
    xml = [xml func_Net2XmlConf(net, '\t\t', enc)];
    xml = [xml '\t\t<Parameters str_engine="mlp_' enc '_engine" int_numLayers="' num2str(net.numLayers) '" bool_usesBias="' biasConnect2str(net.biasConnect) '">\n'];
    
    for i = 1:net.numLayers
        xml = [xml func_Net2XmlLayer(net, i, '\t\t\t', enc)];
    end
    
    xml = [xml '\t\t</Parameters>\n'];
    xml = [xml '\t</MachineLearningModel>\n'];
    xml = [xml '</MLlib_XML_File>\n'];
    
    fileID = fopen(fnstr,'w');
    fprintf(fileID,xml);
    fclose(fileID);
end

function xml = func_Net2XmlConf(net, tab, enc)

    % <Configuration Configuration="4" int_numLayers="4" bool_usesBias="true">
    %     <MlpLayer1 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
    %     <MlpLayer2 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
    %     <MlpLayer3 int_numNeurons="6" str_activationFunction="ACT_FN_SIGMOID"/>
    %     <MlpLayer4 int_numNeurons="3" str_activationFunction="ACT_FN_SIGMOID"/>
    % </Configuration>

    xml = [];
    xml = [xml tab '<Configuration int_numInputNeurons="' num2str(net.input.size) '" int_numLayers="' num2str(net.numLayers) '" bool_usesBias="' biasConnect2str(net.biasConnect) '">\n'];
    for i = 1:net.numLayers
        xml = [xml tab '\t' '<MlpLayer' num2str(i) ' int_numNeurons="' num2str(net.layers{i}.size) '" str_activationFunction="' Str2TransFct(net.layers{i}.transferFcn) '"/>\n'];
    end
    xml = [xml tab '</Configuration>\n'];
    
end

function xml = func_Net2XmlLayer(net, layer, tab, enc)

    % <MlpLayer1 str_type="dense" str_activationFunction="ACT_FN_SIGMOID">
    %     <WeightMatrix str_type="' enc '" int_rows="6" int_columns="5">
    %         <Row1 arr' enc '_vals="0.455443,0.301906,0.541781,-0.253339,-0.639187"/>
    %         <Row2 arr' enc '_vals="0.891971,-0.129105,0.357915,-0.744195,-0.277263"/>
    %         <Row3 arr' enc '_vals="-0.347602,0.323089,-0.912997,-0.23274,0.314637"/>
    %         <Row4 arr' enc '_vals="-0.211747,-0.636116,-0.736092,0.0251508,0.696611"/>
    %         <Row5 arr' enc '_vals="-0.099763,-0.42249,-0.127794,0.311451,-0.75072"/>
    %         <Row6 arr' enc '_vals="0.692093,0.819697,-0.30946,0.30172,0.330007"/>
    %     </WeightMatrix>
    % </MlpLayer1>

    if layer == 1
        inpMat = net.IW{layer}; [numRows,numCols] = size(inpMat);
        inpB = net.b{layer};
        
        if isfield(net.inputs{1}.processSettings{1},'gain') == 1
            gi = net.inputs{1}.processSettings{1}.gain;
            oi = net.inputs{1}.processSettings{1}.xoffset;
            Ascal = diag(gi);
            Bscal = (-diag(gi)*oi-1);
            
            if ~isempty(inpB)
                inpB = inpMat*Bscal + inpB;
            end
            inpMat = inpMat*Ascal;
        end
    elseif layer == net.numLayers
        inpMat = net.LW{layer,layer-1}; [numRows,numCols] = size(inpMat);
        inpB = net.b{layer};
        
        if isfield(net.outputs{net.numLayers}.processSettings{1},'gain') == 1
            go = net.outputs{net.numLayers}.processSettings{1}.gain;
            oo = net.outputs{net.numLayers}.processSettings{1}.xoffset;
            Ascal = diag(go);
            Bscal = (-diag(go)*oo-1);
            Bscal = -inv(Ascal)*Bscal;
            Ascal = inv(Ascal);
            
            if ~isempty(inpB)
                inpB = Ascal*inpB + 1./go + oo;
            end
            inpMat = Ascal*inpMat;
        end
    else
        inpMat = net.LW{layer,layer-1}; [numRows,numCols] = size(inpMat);
        inpB = net.b{layer};
    end
    
    xml = [];
    xml = [xml tab '<MlpLayer' num2str(layer) ' str_type="dense" str_activationFunction="' Str2TransFct(net.layers{layer}.transferFcn) '">\n'];
    
    if net.biasConnect(layer) == 1
        % layer has a bias
        xml = [xml tab '\t<WeightMatrix str_type="' enc '" int_rows="' num2str(numRows) '" int_columns="' num2str(numCols+1) '">\n'];
        for i = 1:numRows
            xml = [xml tab '\t \t <Row' num2str(i) ' arr' enc '_vals="' Row2Str(inpMat(i,:)) ',' sprintf('%16.8e',inpB(i)) '"/>\n'];
        end
        
    elseif net.biasConnect(layer) == 0 &&  sum(net.biasConnect)>=1
        % If there is at least one layer with a bias in the model, but the
        % current layer does not have a bias add a column with zeros
        xml = [xml tab '\t<WeightMatrix str_type="' enc '" int_rows="' num2str(numRows) '" int_columns="' num2str(numCols+1) '">\n'];
        for i = 1:numRows
            xml = [xml tab '\t \t <Row' num2str(i) ' arr' enc '_vals="' Row2Str(inpMat(i,:)) ',' sprintf('%16.8e',0.0) '"/>\n'];
        end
        
    elseif sum(net.biasConnect)==0
        % no layer in the model has a bias 
        xml = [xml tab '\t<WeightMatrix str_type="' enc '" int_rows="' num2str(numRows) '" int_columns="' num2str(numCols) '">\n'];
        for i = 1:numRows
            xml = [xml tab '\t \t <Row' num2str(i) ' arr' enc '_vals="' Row2Str(inpMat(i,:)) '"/>\n'];
        end
    end
    
    xml = [xml tab '\t</WeightMatrix>\n'];
    xml = [xml tab '</MlpLayer' num2str(layer) '>\n']; 
end

function xml = Row2Str(row)
    xml = [];
    xml = [xml sprintf('%16.24e',row(1))];
    for i = 2:length(row)
        xml = [xml ',' sprintf('%16.24e',row(i))];
    end
end

function xml = Str2TransFct(str)
    switch str
        case 'logsig'
            xml = 'ACT_FN_SIGMOID';
        case 'tansig'
            xml = 'ACT_FN_TANH';
        case 'softmax'
            xml = 'ACT_FN_SOFTMAX';
        case 'poslin'
            xml = 'ACT_FN_RELU';
        otherwise
            xml = 'ACT_FN_IDENTITY';
    end
end

function xml = biasConnect2str(biasConnect)
    if sum(biasConnect)>=1
        xml = 'true';
    else
        xml = 'false';
    end
end

% str1 = ['<NeuralNetwork Name="NN1">\n' ...
%         '\t<LayerSizes>\n'];
% 
% str2 = [];
% str2 = [str2 '\t\t<LayerSize Number="0" Value="' num2str(net.input.size) '"/>\n'];
% str2 = [str2 '\t\t<LayerSize Number="1" Value="' num2str(net.input.size) '"/>\n'];
% for i = 1:net.numLayers
%     str2 = [str2 '\t\t<LayerSize Number="' num2str(i+1) '" Value="' num2str(net.layers{i}.size) '"/>\n'];
% end
% str2 = [str2 '\t\t<LayerSize Number="' num2str(net.numLayers+2) '" Value="' num2str(net.output.size) '"/>\n'];
% 
% 
% str3 = ['\t</LayerSizes>\n' ...
%         '\t<Layers>\n'];
%     
%     
% gi = net.inputs{1}.processSettings{1}.gain;
% oi = net.inputs{1}.processSettings{1}.xoffset;
% Ainp = diag(gi);
% Binp = (-diag(gi)*oi-1);
%     
% str4 = ['\t\t<Layer Number="0">\n'];
% 
% inpMat = Ainp; [numRows,numCols] = size(Ainp);
% str4 = [str4 '\t\t\t<WeightMatrix>\n'];
% for i = 0:numCols-1
%     str4 = [str4 '\t\t\t\t<Column Number="' num2str(i) '" Size="' num2str(numRows) '">'];
%     for j = 1:numRows-1
%         str4 = [str4 num2str(inpMat(j,i+1)) ' '];
%     end
%     str4 = [str4 num2str(inpMat(numRows,i+1))];
%     str4 = [str4 '</Column>\n'];
% end
% str4 = [str4 '\t\t\t</WeightMatrix>\n'];
% 
% str4 = [str4 '\t\t\t<Bias>\n'];
% bias = Binp; [numRows,numCols] = size(bias);
% str4 = [str4 '\t\t\t\t<Column Number="0" Size="' num2str(numRows) '">'];
% for i = 1:numRows-1
%     str4 = [str4 num2str(bias(i)) ' '];
% end
% str4 = [str4 num2str(bias(numRows))];
% str4 = [str4 '</Column>\n'];
% str4 = [str4 '\t\t\t</Bias>\n'];
% 
% str4 = [str4 '\t\t\t<TransferFunction Value="Identity"/>\n'];
% str4 = [str4 '\t\t</Layer>\n'];
% 
% 
% 
% 
% str5 = ['\t\t<Layer Number="1">\n'];
% 
% inpMat = net.IW{1}; [numRows,numCols] = size(inpMat);
% str5 = [str5 '\t\t\t<WeightMatrix>\n'];
% for i = 0:numCols-1
%     str5 = [str5 '\t\t\t\t<Column Number="' num2str(i) '" Size="' num2str(numRows) '">'];
%     for j = 1:numRows-1
%         str5 = [str5 num2str(inpMat(j,i+1)) ' '];
%     end
%     str5 = [str5 num2str(inpMat(numRows,i+1))];
%     str5 = [str5 '</Column>\n'];
% end
% str5 = [str5 '\t\t\t</WeightMatrix>\n'];
% 
% str5 = [str5 '\t\t\t<Bias>\n'];
% bias = net.b{1}; [numRows,numCols] = size(bias);
% str5 = [str5 '\t\t\t\t<Column Number="0" Size="' num2str(numRows) '">'];
% for i = 1:numRows-1
%     str5 = [str5 num2str(bias(i)) ' '];
% end
% str5 = [str5 num2str(bias(numRows))];
% str5 = [str5 '</Column>\n'];
% str5 = [str5 '\t\t\t</Bias>\n'];
% 
% str5 = [str5 '\t\t\t<TransferFunction Value="TanH"/>\n'];
% str5 = [str5 '\t\t</Layer>\n'];
% 
% for l = 1:net.numLayers-2
%     str5 = [str5 '\t\t<Layer Number="' num2str(l+1) '">\n'];
%     inpMat = net.LW{l+1,l}; [numRows,numCols] = size(inpMat);
%     str5 = [str5 '\t\t\t<WeightMatrix>\n'];
%     for i = 0:numCols-1
%         str5 = [str5 '\t\t\t\t<Column Number="' num2str(i) '" Size="' num2str(numRows) '">'];
%         for j = 1:numRows-1
%             str5 = [str5 num2str(inpMat(j,i+1)) ' '];
%         end
%         str5 = [str5 num2str(inpMat(numRows,i+1))];
%         str5 = [str5 '</Column>\n'];
%     end
%     str5 = [str5 '\t\t\t</WeightMatrix>\n'];
% 
%     str5 = [str5 '\t\t\t<Bias>\n'];
%     bias = net.b{l+1}; [numRows,numCols] = size(bias);
%     str5 = [str5 '\t\t\t\t<Column Number="0" Size="' num2str(numRows) '">'];
%     for i = 1:numRows-1
%         str5 = [str5 num2str(bias(i)) ' '];
%     end
%     str5 = [str5 num2str(bias(numRows))];
%     str5 = [str5 '</Column>\n'];
%     str5 = [str5 '\t\t\t</Bias>\n'];
% 
%     str5 = [str5 '\t\t\t<TransferFunction Value="TanH"/>\n'];
%     str5 = [str5 '\t\t</Layer>\n'];
% end
%     
% l = net.numLayers-1;
%     str5 = [str5 '\t\t<Layer Number="' num2str(l+1) '">\n'];
%     inpMat = net.LW{l+1,l}; [numRows,numCols] = size(inpMat);
%     str5 = [str5 '\t\t\t<WeightMatrix>\n'];
%     for i = 0:numCols-1
%         str5 = [str5 '\t\t\t\t<Column Number="' num2str(i) '" Size="' num2str(numRows) '">'];
%         for j = 1:numRows-1
%             str5 = [str5 num2str(inpMat(j,i+1)) ' '];
%         end
%         str5 = [str5 num2str(inpMat(numRows,i+1))];
%         str5 = [str5 '</Column>\n'];
%     end
%     str5 = [str5 '\t\t\t</WeightMatrix>\n'];
% 
%     str5 = [str5 '\t\t\t<Bias>\n'];
%     bias = net.b{l+1}; [numRows,numCols] = size(bias);
%     str5 = [str5 '\t\t\t\t<Column Number="0" Size="' num2str(numRows) '">'];
%     for i = 1:numRows-1
%         str5 = [str5 num2str(bias(i)) ' '];
%     end
%     str5 = [str5 num2str(bias(numRows))];
%     str5 = [str5 '</Column>\n'];
%     str5 = [str5 '\t\t\t</Bias>\n'];
% 
%     str5 = [str5 '\t\t\t<TransferFunction Value="Identity"/>\n'];
%     str5 = [str5 '\t\t</Layer>\n'];
% 
%     
% 
% 
% 
% 
% 
% go = net.outputs{2}.processSettings{1}.gain;
% oo = net.outputs{2}.processSettings{1}.xoffset;
% Aout = diag(go);
% Bout = (-diag(go)*oo-1);
% Bout = -inv(Aout)*Bout;
% Aout = inv(Aout);
% 
% str6 = ['\t\t<Layer Number="' num2str(net.numLayers+1) '">\n'];
% 
% inpMat = Aout; [numRows,numCols] = size(Aout);
% str6 = [str6 '\t\t\t<WeightMatrix>\n'];
% for i = 0:numCols-1
%     str6 = [str6 '\t\t\t\t<Column Number="' num2str(i) '" Size="' num2str(numRows) '">'];
%     for j = 1:numRows-1
%         str6 = [str6 num2str(inpMat(j,i+1)) ' '];
%     end
%     str6 = [str6 num2str(inpMat(numRows,i+1))];
%     str6 = [str6 '</Column>\n'];
% end
% str6 = [str6 '\t\t\t</WeightMatrix>\n'];
% 
% str6 = [str6 '\t\t\t<Bias>\n'];
% bias = Bout; [numRows,numCols] = size(bias);
% str6 = [str6 '\t\t\t\t<Column Number="0" Size="' num2str(numRows) '">'];
% for i = 1:numRows-1
%     str6 = [str6 num2str(bias(i)) ' '];
% end
% str6 = [str6 num2str(bias(numRows))];
% str6 = [str6 '</Column>\n'];
% str6 = [str6 '\t\t\t</Bias>\n'];
% 
% str6 = [str6 '\t\t\t<TransferFunction Value="Identity"/>\n'];
% str6 = [str6 '\t\t</Layer>\n'];
% 
% 
% 
% str7 = ['\t</Layers>\n' ...
%         '</NeuralNetwork>\n'];
% 
% 
% strALL = [str1 str2 str3 str4 str5 str6 str7];
% 
% fileID = fopen('NN_MagneticPlatform.xml','w');
% fprintf(fileID,strALL);
% fclose(fileID);

