
%% XML
% <?xml version="1.0" encoding="UTF-8"?>
% <MLlib_XML_File>
% 	<MachineLearningModel modelName="Support_Vector_Machine" defaultEngine="svm_fp64_engine">
% 		<Configuration str_operationType="SVM_TYPE_C_CLASSIFIER" fp64_cost="500" str_kernelFunction="KERNEL_FN_RBF" fp64_gamma="2.7000000000000002" int64_numInputAttributes="2" />
% 		<Parameters str_engine="svm_fp64_engine">
% 			<ModelInfo int64_numClasses="4" int64_numSVs="8" arrint32_classLabels="1,2,3,4" arrint32_numSVsPerClass="3,2,2,1" arrint32_svIndices="1,2,3,5,6,7,8,9" />
% 			<ProbabilityInfo arrfp64_rhoConstants="0.0435064,0.300319,-0.0364984,0.260407,-0.0800211,-0.333333" bool_hasPairwiseProbabilities="false" />
% 			<SupportVectors str_type="fp64" int64_rows="8" int64_columns="2">
% 				<Row1 arrfp64_vals="-3,-3" />
% 				<Row2 arrfp64_vals="-2.9,-3.1" />
% 				<Row3 arrfp64_vals="-2.8,-2.9" />
% 				<Row4 arrfp64_vals="2.8,0.3" />
% 				<Row5 arrfp64_vals="3.1,0.1" />
% 				<Row6 arrfp64_vals="-1,4.2" />
% 				<Row7 arrfp64_vals="-3.9,3.9" />
% 				<Row8 arrfp64_vals="-1,-1" />
% 			</SupportVectors>
% 			<SupportVectorClassCoefficients str_type="fp64" int64_rows="3" int64_columns="8">
% 				<Row1 arrfp64_vals="0.312506,0.313038,0.497098,-0.561055,-0.561587,-0.699335,-0.699335,-1.03656" />
% 				<Row2 arrfp64_vals="0.388503,0.391693,0.618475,0.739475,0.740145,-0.739475,-0.740145,-1.07948" />
% 				<Row3 arrfp64_vals="0.290901,0.288142,0.457519,0.53974,0.53974,0.666016,0.666992,-1.33301" />
% 			</SupportVectorClassCoefficients>
% 		</Parameters>
% 	</MachineLearningModel>
% </MLlib_XML_File>

% <?xml version="1.0" encoding="UTF-8"?>
% <MLlib_XML_File>
% 	<MachineLearningModel modelName="Support_Vector_Machine" defaultEngine="svm_fp64_engine">
% 		<CustomAttributes />
% 		<Configuration str_operationType="SVM_TYPE_ONE_CLASS" fp64_nu="0.5" str_kernelFunction="KERNEL_FN_RBF" fp64_gamma="12.2" int64_numInputAttributes="2" />
% 		<Parameters str_engine="svm_fp64_engine">
% 			<ModelInfo int64_numClasses="2" int64_numSVs="4" arrint32_svIndices="2,4,5,6" />
% 			<ProbabilityInfo fp64_rhoConstants="2.159016972787462" bool_hasPairwiseProbabilities="false" />
% 			<SupportVectors str_type="fp64" int64_rows="4" int64_columns="2">
% 				<Row1 arrfp64_vals="0.45,0.44" />
% 				<Row2 arrfp64_vals="0.41,0.52" />
% 				<Row3 arrfp64_vals="0.71,0.64" />
% 				<Row4 arrfp64_vals="0.58,0.51" />
% 			</SupportVectors>
% 			<SupportVectorClassCoefficients str_type="fp64" int64_rows="1" int64_columns="4">
% 				<Row1 arrfp64_vals="0.970201,0.926556,1,0.103242" />
% 			</SupportVectorClassCoefficients>
% 		</Parameters>
% 	</MachineLearningModel>
% </MLlib_XML_File>

%% functions    
function xml = Svm2Xml(svm, fnstr)
    xml = [];
    xml = [xml '<?xml version="1.0" encoding="UTF-8"?>\n'];
    xml = [xml '<MLlib_XML_File>\n'];
    xml = [xml '\t<MachineLearningModel modelName="Support_Vector_Machine" defaultEngine="svm_fp64_engine">\n'];
    xml = [xml func_Svm2XmlConf(svm, '\t\t')];
    xml = [xml '\t\t<Parameters str_engine="svm_fp64_engine">\n'];
    
    xml = [xml '\t\t\t<ModelInfo int64_numClasses="2" int64_numSVs="' num2str(sum(svm.IsSupportVector)) '" arrint32_svIndices="' func_MakeStrList(find(svm.IsSupportVector)) '"/>\n'];
    xml = [xml '\t\t\t<ProbabilityInfo fp64_rhoConstants="' num2str(-svm.Bias) '" bool_hasPairwiseProbabilities="false" />\n'];
    
    xml = [xml '\t\t\t<SupportVectors str_type="fp64" int64_rows="' num2str(sum(svm.IsSupportVector)) '" int64_columns="' num2str(size(svm.SupportVectors,2)) '">\n'];
    xml = [xml func_Svm2XmlVectors(svm, '\t\t\t')];
    xml = [xml '\t\t\t</SupportVectors>\n'];
    
    xml = [xml '\t\t\t<SupportVectorClassCoefficients str_type="fp64" int64_rows="' num2str(size(svm.Alpha,2)) '" int64_columns="' num2str(size(svm.Alpha,1)) '">\n'];
    xml = [xml func_Svm2XmlCoeffs(svm, '\t\t\t')];
    xml = [xml '\t\t\t</SupportVectorClassCoefficients>\n'];
    
    xml = [xml '\t\t</Parameters>\n'];
    xml = [xml '\t</MachineLearningModel>\n'];
    xml = [xml '</MLlib_XML_File>\n'];
    
    fileID = fopen(fnstr,'w');
    fprintf(fileID,xml);
    fclose(fileID);
end

function str = func_MakeStrList(list)
    str = num2str(list(1));
    for i = 2:length(list)
        str = [str ',' num2str(list(i))];
    end
end

function xml = func_Svm2XmlConf(svm, tab)

    % <Configuration str_operationType="SVM_TYPE_ONE_CLASS" fp64_nu="0.5" str_kernelFunction="KERNEL_FN_RBF" fp64_gamma="12.2" int64_numInputAttributes="2" />

    gamma = 1/svm.ModelParameters.KernelScale^2;
    
    if strcmp(svm.KernelParameters,'gaussian')
        kernelfctstr = 'KERNEL_FN_RBF';
    else
        kernelfctstr = 'KERNEL_FN_RBF';
    end
    xml = [tab '<Configuration str_operationType="SVM_TYPE_ONE_CLASS" fp64_nu="' num2str(svm.ModelParameters.Nu) '" str_kernelFunction="' kernelfctstr '" fp64_gamma="' num2str(gamma) '" int64_numInputAttributes="' num2str(size(svm.X,2)) '"/>\n'];
    
end

function xml = func_Svm2XmlCoeffs(svm, tab)

%   <SupportVectorClassCoefficients str_type="fp64" int64_rows="3" int64_columns="8">
% 		<Row1 arrfp64_vals="0.312506,0.313038,0.497098,-0.561055,-0.561587,-0.699335,-0.699335,-1.03656" />
% 		<Row2 arrfp64_vals="0.388503,0.391693,0.618475,0.739475,0.740145,-0.739475,-0.740145,-1.07948" />
%       <Row3 arrfp64_vals="0.290901,0.288142,0.457519,0.53974,0.53974,0.666016,0.666992,-1.33301" />
%   </SupportVectorClassCoefficients>
    
    alpha  = svm.Alpha';
    
    xml = [];
    for i = 1:size(alpha,1)
        xml = [xml tab '\t<Row' num2str(i) ' arrfp64_vals="' Row2Str(alpha(i,:)) '"/>\n'];
    end
    
end

function xml = func_Svm2XmlVectors(svm, tab)

%     <SupportVectors str_type="fp64" int64_rows="8" int64_columns="2">
%         <Row1 arrfp64_vals="-3,-3" />
%         <Row2 arrfp64_vals="-2.9,-3.1" />
%         <Row3 arrfp64_vals="-2.8,-2.9" />
%         <Row4 arrfp64_vals="2.8,0.3" />
%         <Row5 arrfp64_vals="3.1,0.1" />
%         <Row6 arrfp64_vals="-1,4.2" />
%         <Row7 arrfp64_vals="-3.9,3.9" />
%         <Row8 arrfp64_vals="-1,-1" />
%     </SupportVectors>
    
    xml = [];
    for i = 1:size(svm.SupportVectors,1)
        xml = [xml tab '\t<Row' num2str(i) ' arrfp64_vals="' Row2Str(svm.SupportVectors(i,:)) '"/>\n'];
    end
    
end

function xml = Row2Str(row)
    xml = [];
    xml = [xml sprintf('%16.24e',row(1))];
    for i = 2:length(row)
        xml = [xml ',' sprintf('%16.24e',row(i))];
    end
end
